Gentoo Forums
Gentoo Forums
Gentoo Forums
Quick Search: in
kwin 4.7 and Opengl ES
View unanswered posts
View posts from last 24 hours

 
Reply to topic    Gentoo Forums Forum Index Desktop Environments
View previous topic :: View next topic  
Author Message
i92guboj
Bodhisattva
Bodhisattva


Joined: 30 Nov 2004
Posts: 10310
Location: Córdoba (Spain)

PostPosted: Thu Jul 28, 2011 11:26 am    Post subject: kwin 4.7 and Opengl ES Reply with quote

It seems that kwin 4.7 brings -finally- Opengl ES to our desktops. But after I compiled kwin with USE="-opengl gles" (you can't have both enabled) compositing stops working and I can't re-enable it (kwin crashes and disables it automatically).

My driver is radeon, and mesa is compiled with USE=gles as well. I use the gallium mesa driver as seen here:

Code:
64bit i915 (Intel 915, 945)
64bit i965 (Intel 965, G/Q3x, G/Q4x)
64bit r300 (Radeon R300-R500)
  [1]   gallium *
64bit r600 (Radeon R600-R700, Evergreen, Northern Islands)
  [1]   gallium *
64bit sw (Software renderer)
  [1]   gallium *
32bit i915 (Intel 915, 945)
  [1]   classic *
  [2]   gallium
32bit i965 (Intel 965, G/Q3x, G/Q4x)
  [1]   classic *
  [2]   gallium
32bit r300 (Radeon R300-R500)
  [1]   classic
  [2]   gallium *
32bit r600 (Radeon R600-R700, Evergreen, Northern Islands)
  [1]   classic
  [2]   gallium *
32bit sw (Software renderer)
  [1]   classic
  [2]   gallium *


So, has anyone tried to enable gles in kwin with the radeon driver? Anyone succeeded?
_________________
Gentoo Handbook | My website
Back to top
View user's profile Send private message
ppurka
Advocate
Advocate


Joined: 26 Dec 2004
Posts: 3256

PostPosted: Thu Jul 28, 2011 12:16 pm    Post subject: Re: kwin 4.7 and Opengl ES Reply with quote

i92guboj wrote:
It seems that kwin 4.7 brings -finally- Opengl ES to our desktops.
I thought opengles is not for desktops but for mobiles. See wikipedia :)

In case, it can be used for desktops too, it means that there are probably issues with the radeon driver you have.
_________________
emerge --quiet redefined | E17 vids: I, II | Now using kde5 | e is unstable :-/
Back to top
View user's profile Send private message
Dorsai!
Apprentice
Apprentice


Joined: 27 Jul 2008
Posts: 280
Location: Bavaria

PostPosted: Thu Jul 28, 2011 1:53 pm    Post subject: Reply with quote

I have the same problem with the latest (and previous) nvidia-drivers. I had to go back to opengl.

OpenGLES is not only for mobiles. It is recommended by upstream (bzw. Martin Gräßlin) since it should be faster and more bug free.
Back to top
View user's profile Send private message
i92guboj
Bodhisattva
Bodhisattva


Joined: 30 Nov 2004
Posts: 10310
Location: Córdoba (Spain)

PostPosted: Thu Jul 28, 2011 3:22 pm    Post subject: Re: kwin 4.7 and Opengl ES Reply with quote

ppurka wrote:
i92guboj wrote:
It seems that kwin 4.7 brings -finally- Opengl ES to our desktops.
I thought opengles is not for desktops but for mobiles. See wikipedia :)

In case, it can be used for desktops too, it means that there are probably issues with the radeon driver you have.


Certainly not all of this is clear to me. I think it's the recommended opengl engine for kwin right now, and it's where most of of the future kwin development will take place, relegating all the rest of backends to a secondary place. In any case, we have a bug here of some kind. If this is to work on desktop, then the bug is in radeon, mesa, kwin or all of them. If not, then the bug is in the ebuilds, which should mask the gles use flag for those architectures where gles is not going to work. In any case, the mesa ebuild has had this flag for some time now, so I don't know what to think. That's why I am asking in the forum before blindingly reporting bugs in b.g.o. or upstream.
_________________
Gentoo Handbook | My website
Back to top
View user's profile Send private message
Dorsai!
Apprentice
Apprentice


Joined: 27 Jul 2008
Posts: 280
Location: Bavaria

PostPosted: Fri Jul 29, 2011 10:32 pm    Post subject: Reply with quote

Any solution for this yet?

Has anyone a working kwin gles setup?
Back to top
View user's profile Send private message
NismoC32
Apprentice
Apprentice


Joined: 07 Apr 2003
Posts: 202

PostPosted: Sat Jul 30, 2011 3:27 am    Post subject: Reply with quote

No luck with "gles" here using a ASUS NVidia GTX 465 card with the binary blob 275.21 (OpenGL/ES v4.1.0)
Back to top
View user's profile Send private message
chithanh
Developer
Developer


Joined: 05 Aug 2006
Posts: 2152
Location: Berlin, Germany

PostPosted: Sat Jul 30, 2011 8:25 am    Post subject: Reply with quote

The crash is due to bug 376981. Upgrade to mesa-7.11_rc4, it is fixed there.
Back to top
View user's profile Send private message
albright
Advocate
Advocate


Joined: 16 Nov 2003
Posts: 2588
Location: Near Toronto

PostPosted: Sat Jul 30, 2011 12:52 pm    Post subject: Reply with quote

does anyone know if gles works with intel GM965/GL960
(it did NOT work with older mesa)

and just how much faster/smoother/better is it than plain old gl
_________________
.... there is nothing - absolutely nothing - half so much worth
doing as simply messing about with Linux ...
(apologies to Kenneth Graeme)
Back to top
View user's profile Send private message
abulak
n00b
n00b


Joined: 12 Dec 2008
Posts: 29

PostPosted: Mon Aug 01, 2011 11:30 am    Post subject: Reply with quote

I have gentoo-sources-3.0;
kwin-4.7 and mesa-7.11-rc4

kwin will not run with USE="gles -opengl"

during startup it says:
Code:
 OpenGL renderer string: Gallium 0.4 on NV4E
 OpenGL version string: OpenGL ES 2.0 Mesa 7.11-rc4
 OpenGL shading language version string: OpenGL ES GLSL ES 1.0.16
 Driver: Nouveau
 GPU class: NV40/G70
 OpenGL version: 2.0
 GLSL version: 1.0.16
 Mesa version: 7.11
 X server version: 1.10.3
 Linux kernel version: 3.0
 Direct rendering: yes
 Requires strict binding: yes
 GLSL shaders: limited
 Texture NPOT support: yes
 kwin(20091): Shaders are not supported
 kwin(20091): Shaders not valid, ES compositing not possible
 kwin(20091): Failed to initialize compositing, compositing disabled


It is old Geforce Go 6150 which is definitely capable of OpenGL-2.0...

I guess it is too old to be actively supported by nouveau developers...
Back to top
View user's profile Send private message
i92guboj
Bodhisattva
Bodhisattva


Joined: 30 Nov 2004
Posts: 10310
Location: Córdoba (Spain)

PostPosted: Mon Aug 01, 2011 12:01 pm    Post subject: Reply with quote

@abulak, as far as I know nouveau doesn't even have a proper mesa hardware driver, check "eselect mesa list". I could be wrong, admittedly I never used it myself.

@allbright, I don't notice any improvement (or detriment) in performance. I am not too intensive in effects though. I only use a slight transparency in the window decos and while moving windows around. Effects are not 100% smooth (they never were) with my radeon card (using the open radeon driver). Anyway, that was to be expected. If every time an improvement is announced it was always true, then kwin would run a a million thousands percent of its original speed. ;)
_________________
Gentoo Handbook | My website
Back to top
View user's profile Send private message
Yamakuzure
Advocate
Advocate


Joined: 21 Jun 2006
Posts: 2277
Location: Bardowick, Germany

PostPosted: Wed Aug 03, 2011 11:07 am    Post subject: Reply with quote

albright wrote:
does anyone know if gles works with intel GM965/GL960
(it did NOT work with older mesa)

and just how much faster/smoother/better is it than plain old gl
As far as I can see you need Gallium3D support for OpenGL-ES to work. On my Intel HD (i965) it does not work, I tried yesterday.
On http://www.x.org/wiki/GalliumStatus The status for "Mesa" and "DRI" are set to "Work in Progress" for i965.
_________________
Important German:
  1. "Aha" - German reaction to pretend that you are really interested while giving no f*ck.
  2. "Tja" - German reaction to the apocalypse, nuclear war, an alien invasion or no bread in the house.
Back to top
View user's profile Send private message
Yamakuzure
Advocate
Advocate


Joined: 21 Jun 2006
Posts: 2277
Location: Bardowick, Germany

PostPosted: Thu Aug 04, 2011 9:05 am    Post subject: Reply with quote

Okay, this is strange. I set mesa to "-gallium" and activated egl and gles where possible. Now portage moans:
Code:
The following USE changes are necessary to proceed:
#required by media-libs/evas-9999[gles], required by media-libs/edje-9999, required by x11-plugins/e_modules-forecasts-9999, required by x11-plugins/e_modules-9999, required by @selected, required by @world (argument)
=media-libs/mesa-7.11 gallium
#required by dev-python/PyQt4-4.8.4[opengl], required by kde-base/marble-4.7.0-r1[python], required by kde-base/kdeedu-meta-4.7.0, required by kde-base/kde-meta-4.7.0, required by @selected, required by @world (argument)
>=x11-libs/qt-opengl-4.7.3 -egl
So while mesa and kwin are perfectly happy with +gles and -gallium, evas wants it.

I changed evas to "-gles" and PyQt4 to "-opengl" and portage is happy with this combination. Now I can test whether I have understood the OpenGL ES documentation on the mesa website correctly. ;) If I did, then it won't work out this way.

Edit 1: Hmmm... mesa fails in configure phase with "-gallium" and "openvg". The ebuild should really know, so I'll file a bug report.

Edit 2: HA! Even with Gallium disabled, the gallium drivers are built due to the Usage of EGL which is mandatory for OpenGL ES.

Edit 3: Finally tested it. kwin-4.7.0 is now merged with "-opengl +gles" and mesa-7.11 is merged with "+egl +gles -gallium" and kwin no longer crashes but works with enabled desktop effects on OpenGL backend. "eselect mesa list" still shows the presence of "Gallium", but "classic" is enabled.
_________________
Important German:
  1. "Aha" - German reaction to pretend that you are really interested while giving no f*ck.
  2. "Tja" - German reaction to the apocalypse, nuclear war, an alien invasion or no bread in the house.
Back to top
View user's profile Send private message
opotonil
l33t
l33t


Joined: 17 Jun 2005
Posts: 801
Location: 127.0.0.1

PostPosted: Sat Aug 13, 2011 6:52 pm    Post subject: Reply with quote

I am trying to use it with nvidia (private driver) but I get:
Code:

libEGL warning: GLX/DRI2 is not supported
OpenGL vendor string:                   VMware, Inc.
OpenGL renderer string:                 Gallium 0.4 on llvmpipe
OpenGL version string:                  OpenGL ES 2.0 Mesa 7.11
Driver:                                 LLVMpipe
GPU class:                              Unknown
OpenGL version:                         2.0
Mesa version:                           7.11
X server version:                       1.10.2
Linux kernel version:                   2.6.38
Direct rendering:                       yes
Requires strict binding:                yes
GLSL shaders:                           no
Texture NPOT support:                   yes
kwin(4946): ""fsrestore1" - conversion of "0,0,0,0" to QRect failed"
kwin(4946): Required extension EGL_KHR_image_pixmap not found, disabling compositing
kwin(4946): Failed to initialize compositing, compositing disabled

I do not have installed VMware and the system not is a virtual machine, video card is NVIDIA GPU GeForce 8400M GT (G86M) and it is using nvidia-drivers-270.41.19 (I get same result with nvidia-drivers-275.21).

USE flags:
Code:

# emerge -pv mesa kwin

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild   R   ~] media-libs/mesa-7.11  USE="egl gallium gbm gles llvm nptl openvg shared-glapi -bindist -classic -debug -motif -pax_kernel -pic (-selinux) -shared-dricore" VIDEO_CARDS="-intel -mach64 -mga -nouveau -r128 -radeon -savage -sis -tdfx -via -vmware" 0 kB
[ebuild   R   ~] kde-base/kwin-4.7.0  USE="gles xcomposite (-aqua) -debug (-kdeenablefinal) -opengl -xinerama" 0 kB

Total: 2 packages (2 reinstalls), Size of downloads: 0 kB


I activated USE flag gbm because in mesa ebuild I can see (bug 376981 posted before):
Code:

--with-egl-platforms=x11$(use gbm && echo ",drm")
Back to top
View user's profile Send private message
Kollin
Veteran
Veteran


Joined: 25 Feb 2006
Posts: 1137
Location: Sofia/Bulgaria

PostPosted: Thu Sep 08, 2011 1:01 pm    Post subject: Reply with quote

For me kwin-4.7.1+gles+nvidia-drivers=no desktop effects.. I'm reverting to opengl :wink:
_________________
"Dear Enemy: may the Lord hate you and all your kind, may you be turned orange in hue, and may your head fall off at an awkward moment."
"Linux is like a wigwam - no windows, no gates, apache inside..."
Back to top
View user's profile Send private message
simcop2387
Apprentice
Apprentice


Joined: 14 Aug 2002
Posts: 200
Location: Galactic Sector ZZ9 Plural Z Alpha

PostPosted: Mon Oct 10, 2011 7:35 pm    Post subject: Reply with quote

for what it's worth.

I'm currently running the live ebuilds of mesa from the x11 overlay. I've got USE="gallium gles1 gles2" enabled, and I've got kwin installed using gles instead of opengl. This makes me believe that it's just a question of support in mesa. I've got a Radeon Mobility HD 4200 on my laptop and performance appears to be pretty good actually.
_________________
1+1=11=2
Back to top
View user's profile Send private message
Display posts from previous:   
Reply to topic    Gentoo Forums Forum Index Desktop Environments All times are GMT
Page 1 of 1

 
Jump to:  
You cannot post new topics in this forum
You cannot reply to topics in this forum
You cannot edit your posts in this forum
You cannot delete your posts in this forum
You cannot vote in polls in this forum